"use strict";

var AudioDataUtils = require("./AudioDataUtils");

/**
 * @param {function}  encodeFn
 * @param {AudioData} audioData
 * @param {object}    opts
 */
function encode(encodeFn, audioData) {
  var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!AudioDataUtils.isAudioData(audioData)) {
    audioData = AudioDataUtils.toAudioData(audioData);
  }
  return encodeFn(audioData, opts);
}

module.exports = { encode: encode };